<?php
/*
** functions.php
** Diese Datei ist Bestandteil des Tagesschau-Archivs
** $Id: functions.php,v 1.1 2010/08/12 03:53:02 elias Exp $
**
** Veröffentlicht unter Piratenlizenz, Share and Enjoy, but don't sue me!
** http://wwwut.wordpress.com/lizenz/
*/


// Konvertieren eines Strings für die Anzeige
function get_htmlstr ($str)
{
  return htmlentities ($str, ENT_QUOTES, 'UTF-8', true);
}

// Erzeugen eines Links
function get_htmllink ($href, $text, $title=null)
{
  $text = get_htmlstr ($text);
  $l = "<a href=\"$href\"";
  if ($title) { $title = get_htmlstr ($title); $l .= " title=\"$title\""; }
  $l .= ">$text</a>";
  return $l;
}

// Datum aus DATETIME extrahieren
function get_datepart ($datetime)
{
  return preg_replace ('/\s*\d+:\d+:\d+$/', '', $datetime);
}

// Anzeige einer Meldungsübersicht aus einem MySQL-Resultset
function show_liste_meldungen ($mrc, $modnam, $add=none)
{
?>
<table class="meldliste">
<tr>
<th class="datum">Datum</th>
<th class="titel">Meldung</th>
</tr>
<?php
  if ($add) { $append = '&' . $add; }
  $even = 0;
  while ($row = mysql_fetch_array ($mrc, MYSQL_ASSOC))
  {
    $even ^= 1;
    $eclass = $even ? 'even' : 'odd';
    $ldatum = get_datepart ($row['meld_pubdatum']);
    echo "<tr class=\"$eclass\">\n";
    echo '<td class="datum">' . get_htmllink ($_SERVER['PHP_SELF'] . "?mod=datum&for=$ldatum", $row['meld_pubdatum'], "Meldungen für $ldatum") . "</td>\n";
    echo '<td class="titel">' . get_htmllink ($_SERVER['PHP_SELF'] . "?mod=$modnam&single=" . $row['meld_id'] . $append, $row['meld_titel'] ? $row['meld_titel'] : '(Kein Titel vorhanden)', 'Meldung anzeigen') . "</td>\n";
    echo "</tr>\n";
  }
?>
</table>
<?php
}

// Datumsstring aus einem HTML-Formular ermitteln
function get_date_string ($name, $forend=false)
{
  if ($_REQUEST[$name])
  {
    list ($y, $m, $d) = sscanf ($_REQUEST[$name], '%d-%d-%d');
  }
  else
  {
    $d = $_REQUEST["$name-day"];
    $m = $_REQUEST["$name-month"];
    $y = $_REQUEST["$name-year"];
  }
  if (!$y) { return null; }
  if (!$d) { $d = $forend ? 31 : 1; }
  if (!$m) { $m = $forend ? 12 : 1; }
  return sprintf('%04d-%02d-%02d', $y, $m, $d);
}

// Link auf eine Kategorie erzeugen
function get_kat_link ($katid, $katname)
{
  return get_htmllink ($_SERVER['PHP_SELF'] . '?mod=tags&tagid=' . $katid, $katname, "Nachrichten für $katname anzeigen");
}

// Anzeige eines Elementes zur Datumsauswahl
function show_date_selector ($name)
{
  global $global_minyear, $global_maxyear;
  $mn = array (null,
    'Januar', 'Februar', 'März',
    'April', 'Mai', 'Juni',
    'Juli', 'August', 'September',
    'Oktober', 'November', 'Dezember'
  );
  if ($_REQUEST[$name])
  {
    list ($y, $m, $d) = sscanf ($_REQUEST[$name], '%d-%d-%d');
  }
  else
  {
    $y = $_REQUEST["$name-year"];
    $m = $_REQUEST["$name-month"];
    $d = $_REQUEST["$name-day"];
  }
  echo "<label for=\"$name-year\">Jahr:</label>\n";
  echo "<select name=\"$name-year\" id=\"$name-year\">\n";
  for ($i = $global_minyear; $i <= $global_maxyear; ++$i)
  {
    echo "<option value=\"$i\"";
    if ($i == $y) { echo ' selected'; }
    echo ">$i</option>\n";
  }
  echo "</select>\n";
  echo "<label for=\"$name-month\">Monat:</label>\n";
  echo "<select name=\"$name-month\" id=\"$name-month\">\n";
  for ($i = 1; $i <= 12; ++$i)
  {
    echo "<option value=\"$i\"";
    if ($i == $m) { echo ' selected'; }
    echo '>' . $mn[$i] . "</option>\n";
  }
  echo "</select>\n";
  echo "<label for=\"$name-day\">Tag:</label>\n";
  echo "<select name=\"$name-day\" id=\"$name-day\">\n";
  for ($i = 1; $i <= 31; ++$i)
  {
    echo "<option value=\"$i\"";
    if ($i == $d) { echo ' selected'; }
    echo ">$i</option>\n";
  }
  echo "</select>\n";
}

// Anzeige einer Meldung zu einer Meldungs-ID
function show_meldung ($id)
{
  $id = mysql_real_escape_string ($id);
  $r = mysql_query ("	select 	meld_pubdatum,
  				meld_kurztitel, meld_titel,
  				meld_kurztext, meld_text
  			from	meldung
  			where	meld_id = '$id'");
  $row = mysql_fetch_array ($r, MYSQL_ASSOC);
  if (!$row)
  {
    echo "<h2>Nicht existente Meldung</h2>\n";
    echo "<p>Diese Meldung existiert nicht.</p>\n";
    return;
  }
  mysql_free_result ($r);
  $ldatum = get_datepart ($row['meld_pubdatum']);
  echo '<div class="meldmeta">';
  echo '<div class="melddatum">' . get_htmllink ($_SERVER['PHP_SELF'] . "?mod=datum&for=$ldatum", $row['meld_pubdatum'], "Meldungen für $ldatum anzeigen") . '</div>';
  echo '<ul class="kategorien">';
  $r = mysql_query("	select	kat_id, kat_name
  			from	kategorie
  			join	v_kat_meld on v_kat = kat_id
  			where	v_meld = '$id'
  			order	by kat_count desc");
  while ($r2 = mysql_fetch_array ($r, MYSQL_ASSOC))
  {
    echo '<li>' . get_kat_link ($r2['kat_id'], $r2['kat_name']) . '</li>';
  }
  echo '</ul>';
  echo '</div>';
  echo '<h2 class="meldtitel">';
  if ($row['meld_kurztitel'])
  {
    echo '<span class="short">' . get_htmlstr ($row['meld_kurztitel']) . '</span> ';
  }
  echo $row['meld_titel'] ? get_htmlstr ($row['meld_titel']) : '(Kein Titel angegeben)';
  echo "</h2>\n";
  if (strlen (trim ($row['meld_kurztext'])) > 16)
  {
    echo "<div class=\"meldteaser\">\n";
    echo $row['meld_kurztext'];
    echo "\n</div>\n";
  }
  if ($row['meld_text'])
  {
    echo "<div class=\"meldtext\">\n";
    $ps = explode ("\n\n", $row['meld_text']);
    foreach ($ps as $p)
    {
      $p = trim ($p);
      if (strlen ($p) > 0) { echo '<p>' . $p . "</p>\n"; }
    }
    echo "</div>\n";
  }
}


?>
